#define REM #
#define REMLINE ###

#define ECHO(x) x

#ifdef unix
# define SYSTEM_NAME \unix
# define SYSTEM_TYPE att
# define _Output(file) >file
# define _Executable(file) file
# define _Library(file) file
# define _Object(file) file.o
# define _SubDir(d1,d2) d1/d2
# define _Dir(dir) dir
# define _Pathname(dir,file) dir/file
# define ROOT_DIR /
# define AR_CMD ar rvu
# define DEL_CMD rm -f
# define COPY_CMD cp
# define CHDIR_CMD cd
# define LINT_CMD lint
# define MKTAGS_CMD ctags
# define PRINT_CMD pr
# define RANLIB_CMD ranlib
# define SHAR_CMD shar
# define SQZ_CMD compress -v
#endif

#ifdef vms
# define SYSTEM_NAME \vms
# define SYSTEM_TYPE dec
# define _Output(file) /OUTPUT=file
# define _Executable(file) file.exe
# define _Library(file) file
# define _Object(file) file.obj
# define _SubDir(d1,d2) d1.d2
# define _Dir(dir) [dir]
# define _Pathname(dir,file) ECHO(dir)file
# define ROOT_DIR
# define AR_CMD ar rvu
# define DEL_CMD delete/file
# define COPY_CMD copy/file
# define CHDIR_CMD set/dir
# define LINT_CMD lint
# define MKTAGS_CMD ctags
# define PRINT_CMD type
# define RANLIB_CMD ranlib
# define SHAR_CMD shar
# define SQZ_CMD compress/file
#endif

#if ( defined(AZTEC) || defined(MANX) )
# define SYSTEM_NAME amiga
# define SYSTEM_TYPE commodore
# define _Output(file) >file
# define _Executable(file) file.exe
# define _Library(file) file
# define _Object(file) file.obj
# define _SubDir(d1,d2) d1/d2
# define _Dir(dir) dir
# define _Pathname(dir,file) dir/file
# define ROOT_DIR /
# define AR_CMD ar rvu
# define DEL_CMD rm -f
# define COPY_CMD cp
# define CHDIR_CMD cd
# define LINT_CMD lint
# define MKTAGS_CMD ctags
# define PRINT_CMD type
# define RANLIB_CMD ranlib
# define SHAR_CMD shar
# define SQZ_CMD compress -v
#endif

#ifdef MS_DOS
# define SYSTEM_NAME dos
# define SYSTEM_TYPE ibm
# define _Output(file) >file
# define _Executable(file) file.exe
# define _Library(file) file
# define _Object(file) file.obj
# define _SubDir(d1,d2) d1\\d2
# define _Dir(dir) dir
# define _Pathname(dir,file) dir\\file
# define ROOT_DIR \\
# define AR_CMD ar rvu
# define DEL_CMD del
# define COPY_CMD copy
# define CHDIR_CMD cd
# define LINT_CMD lint
# define MKTAGS_CMD ctags
# define PRINT_CMD type
# define RANLIB_CMD ranlib
# define SHAR_CMD shar
# define SQZ_CMD arc -c
#endif

#ifdef OS2
# define SYSTEM_NAME os2
# define SYSTEM_TYPE ibm
# define _Output(file) >file
# define _Executable(file) file.exe
# define _Library(file) file
# define _Object(file) file.obj
# define _SubDir(d1,d2) d1\\d2
# define _Dir(dir) dir
# define _Pathname(dir,file) dir\\file
# define ROOT_DIR \\
# define AR_CMD ar rvu
# define DEL_CMD del
# define COPY_CMD copy
# define CHDIR_CMD cd
# define LINT_CMD lint
# define MKTAGS_CMD ctags
# define PRINT_CMD type
# define RANLIB_CMD ranlib
# define SHAR_CMD shar
# define SQZ_CMD arc -c
#endif

REM $Header: Makefile,v 2.1 89/12/30 20:59:01 eric Exp $

REMLINE
REM operating-system dependent stuff
REMLINE
.UNIVERSE =	SYSTEM_TYPE
OS_TYPE =	SYSTEM_NAME
REM OS_DEFS =	-D${OS_TYPE} -D${.UNIVERSE}_universe

REMLINE
REM targets
REMLINE
NAME =	parseargs
PROGRAM =	_Executable(${NAME})
LIBRARY =	_Library(${NAME})
STYLE =	SYSTEM_NAME

REMLINE
REM target directories
REMLINE
LOCAL =	_Dir(_SubDir(usr,local))
LIBDIR =	_Dir(_SubDir(${LOCAL},lib))
INCDIR =	_Dir(_SubDir(${LOCAL},include))

REMLINE
REM compilation options
REMLINE
INCLUDES =	-I.
REM MODEL =	-Ms
REM MODELNAME =	S
OPT =	-O
REM OPT =	-g
TEST_DEFS =	
USR_DEFS =	-DUSE_PAGER
DEFINES =	${OS_DEFS} ${USR_DEFS} ${TEST_DEFS} -D${STYLE}_style
OPTIONS =
CFLAGS =	${OPT} ${MODEL} ${INCLUDES} ${DEFINES} ${OPTIONS}
LINTFLAGS =	${INCLUDES} ${DEFINES} ${OPTIONS}

REMLINE
REM libraries
REMLINE
LIBARGS =	${MODELNAME}lib${STYLE}_args.a
LIBFILE =	${MODELNAME}libparse.a
LOCLIBS =	${LIBARGS}
REM SYSLIBS =	-lm -lcurses -ltermcap
LIBS =	${LOCLIBS} ${SYSLIBS}

REMLINE
REM commands
REMLINE
AR =	AR_CMD
DEL =	DEL_CMD
COPY =	COPY_CMD
CHDIR =	CHDIR_CMD
LINT =	LINT_CMD
MKTAGS =	MKTAGS_CMD
PRINT =	PRINT_CMD
RANLIB =	RANLIB_CMD
SHAR =	SHAR_CMD
SQZ =	SQZ_CMD

REMLINE
REM files used
REMLINE
DOCS=	doc/Makefile \
		doc/argtype.man3 \
		doc/parseargs.man1 \
		doc/parseargs.man3 \
		doc/parsecntl.man3 \
		doc/arg_macros.inc \
		doc/argdesc.inc \
		doc/argflags.inc \
		doc/argvalopt.inc \
		doc/bugs.inc \
		doc/caveats.inc \
		doc/cmd_macros.inc \
		doc/defargs.inc \
		doc/env_args.inc \
		doc/env_parse.inc \
		doc/env_usage.inc \
		doc/fparseargs3.inc \
		doc/lib_bugs.inc \
		doc/lparseargs3.inc \
		doc/multivals.inc \
		doc/parseargs1.inc \
		doc/parseargs3.inc \
		doc/parsecntl3.inc \
		doc/parsecntls.inc \
		doc/parseflags.inc \
		doc/parsemodes.inc \
		doc/returns.inc \
		doc/sh_arrays.inc \
		doc/shells.inc \
		doc/sparseargs3.inc \
		doc/usage3.inc \
		doc/vparseargs3.inc
SCRIPTS =	test.sh  test.csh  test.ksh  test.rc  test.awk  test.pl
TEMPLATES =	${NAME}.pl  ${NAME}.awk
XXFILES =	Intro  README  MANIFEST  Makefile  Makefile.cpp

HDRS =	${NAME}.h \
		pgopen.h \
		strfuncs.h \
		useful.h

SRCS =	${NAME}.c \
		argtype.c \
		arglist.c \
		amiga_args.c \
		ibm_args.c \
		pgopen.c \
		stest.c \
		strfuncs.c \
		syserr.c \
		unix_args.c \
		unix_man.c \
		vms_args.c \
		vprintf.c \
		winsize.c \
		xparse.c

OBJS = _Object(${STYLE}_args) \
		_Object(arglist) \
		_Object(argtype) \
		_Object(pgopen) \
		_Object(strfuncs) \
		_Object(syserr) \
		_Object(vprintf) \
		_Object(winsize) \
		_Object(xparse)

PROG_OBJS = _Object(${NAME})  _Object(unix_man)
TEST_OBJS = _Object(stest)

FILES =	${XXFILES} ${DOCS} ${HDRS} ${SRCS} ${TEMPLATES} ${SCRIPTS}

REMLINE
REM target dependencies
REMLINE
all: ${LIBARGS} test ${PROGRAM}

test: ${STYLE}_test

${STYLE}_test : _Object(stest) ${LOCLIBS}
	${CC} ${CFLAGS} -o ${STYLE}_test _Object(stest) ${LOCLIBS} ${SYSLIBS}

${LIBARGS}: ${OBJS}
	${AR} $@ ${OBJS}
	${RANLIB} $@

${PROGRAM}: ${PROG_OBJS} ${LOCLIBS}
	${CC} ${CFLAGS} -o $@ ${PROG_OBJS} ${LOCLIBS} ${SYSLIBS}

REMLINE
REM object dependencies
REMLINE
${NAME}.o:	${NAME}.c ${NAME}.h strfuncs.h useful.h
amiga_args.o:	amiga_args.c ${NAME}.h pgopen.h strfuncs.h useful.h
arglist.o:	arglist.c ${NAME}.h strfuncs.h useful.h
argtype.o:	argtype.c ${NAME}.h strfuncs.h useful.h
ibm_args.o:	ibm_args.c ${NAME}.h pgopen.h strfuncs.h useful.h
pgopen.o:	pgopen.c useful.h
stest.o:	stest.c ${NAME}.h useful.h
strfuncs.o:	strfuncs.c useful.h
syserr.o:	syserr.c useful.h
unix_args.o:	unix_args.c ${NAME}.h pgopen.h strfuncs.h useful.h
unix_man.o:	unix_man.c ${NAME}.h strfuncs.h useful.h
vms_args.o:	vms_args.c ${NAME}.h pgopen.h strfuncs.h useful.h
vprintf.o:	vprintf.c useful.h
winsize.o:	winsize.c useful.h
xparse.o:	xparse.c ${NAME}.h strfuncs.h useful.h

REMLINE
REM installation dependencies
REMLINE
install: _Pathname(${INCDIR},${NAME}.h) \
		_Pathname(${LIBDIR},${LIBFILE}) \
		_Pathname(${LOCAL},${PROGRAM})

_Pathname(${INCDIR},${NAME}.h): ${NAME}.h useful.h
	( ${CHDIR} ${INCDIR}; ${DEL} ${NAME}.h useful.h )
	${COPY} ${NAME}.h useful.h ${INCDIR}

_Pathname(${LIBDIR},${LIBFILE}): ${LIBARGS}
	${DEL}  _Pathname(${LIBDIR},${LIBFILE})
	${COPY} ${LIBARGS}  _Pathname(${LIBDIR},${LIBFILE})
	${RANLIB}  _Pathname(${LIBDIR},${LIBFILE})

_Pathname(${LOCAL},${PROGRAM}): ${PROGRAM} ${TEMPLATES}
	( ${CHDIR} ${LOCAL} ; ${DEL} ${PROGRAM} ${TEMPLATES} )
	${COPY} ${PROGRAM} ${TEMPLATES} ${LOCAL}

REMLINE
REM maintenance dependencies
REMLINE
lint: ${SRCS}
	${LINT} ${LINTFLAGS} ${SRCS}

shar: ${NAME}.shar

${NAME}.shar: ${FILES}
	${DEL} ${NAME}.shar
	${SHAR} ${FILES} _Output(${NAME}.shar)

clean:
	${DEL} ${OBJS} ${PROG_OBJS} ${TEST_OBJS}
	${DEL} tags core .exrc

clobber: clean
	${DEL} ${LIBARGS}  ${PROGRAM}  ${STYLE}_test

tags: ${SRCS} ${HDRS}
	${MKTAGS} ${SRCS} ${HDRS}

collapse: clobber shar
	${SQZ} ${NAME}.shar
	${DEL} ${FILES}

print: ${SRCS} ${HDRS}
	@${PRINT} ${SRCS} ${HDRS}

